'''
Created on Sep 5, 2011

@author: lucas
'''
import urllib, urllib2

class Authenticator():
    """
    logs into some website and provides an opener for further access - based on http://stackoverflow.com/questions/5082128/how-do-i-authenticate-a-urllib2-script-in-order-to-access-https-web-services-from
    """
    def __init__(self, loginUrl, username=None, password=None):
        try:
            login_url = loginUrl
            cookieHandler = urllib2.HTTPCookieProcessor()
            self.opener = urllib2.build_opener( urllib2.HTTPSHandler(), cookieHandler )
            urllib2.install_opener( self.opener )
            login_page = self.opener.open( login_url )
            # attempt to get the csrf token from the cookie jar
            self.cj= cookieHandler.cookiejar
            csrf_cookie = None
            for cookie in cookieHandler.cookiejar:
                if cookie.name == 'csrftoken':
                    csrf_cookie = cookie
                    break
            if not csrf_cookie:
                raise Exception('No csrf cookie found.')
            else:
                print "found csrf cookie: " + str( csrf_cookie ) 
                print "csrf_token: ", csrf_cookie.value 
                # login using the usr, pwd, and csrf token
                login_data = urllib.urlencode( dict( username=username, password=password, csrfmiddlewaretoken=csrf_cookie.value ) )
                req = urllib2.Request( login_url, login_data )
                req.add_header( 'Referer', login_url )      #ensures that request origin is legit
                response = urllib2.urlopen( req )
                if response.geturl() == login_url:          # should be redirected to the page here, if back at login url -> refused
                    raise Exception('Authentication refused.')
                print '\t%s is logged in' % username 
        except Exception as e:
            print 'Login failed! Exception: ', e
            raise e
            
    def openAndRead(self, aUrl):
        page = None
        try:
            response = self.opener.open(aUrl)   #try to open url
            page = response.read()
        except (urllib2.HTTPError, urllib2.URLError), e:
                print 'ERROR: ', str(e), '\n\tCould not read the following URL: ', aUrl
        return page