'''
Created on Oct 9, 2011

@author: lucas
'''

from graph import Graph
from writer import Writer
import time

class Reporter(object):
    '''
    generates the reports into the results page
    '''

    def __init__(self, aUrl, aMossResultsList, anAuthenticator, aLocalResultsList):
        self.url = aUrl
        self.graph = Graph()
        self.writer = Writer(anAuthenticator)
        self.mossResults = aMossResultsList
        self.localResults = aLocalResultsList
    
    def generateReport(self):
        try:
            self.graph.buildGraphFromMossResults(self.mossResults, self.localResults)
            date = time.localtime() #can't upload with an existing filename in a page's attachments. Must generate a new one every time.
            self.imageFilePath = 'similarityGraph'+ str(date[1]) + str(date[2])+ str(date[3])+ str(date[4]) + str(date[5]) +'.jpg'
            self.graph.drawImageToFile(self.imageFilePath)
            self.writer.uploadFile(self.url, self.imageFilePath, 'image/jpeg')
            reportContents = self.generateTextContents()
            self.writer.writeContent(self.url, reportContents)
        except Exception as e:
            print 'Report generation error: ', e
            print self.url
            raise e
        return True
    
    def generateTextContents(self):
        outputText = 'Source code similarity report:\n\n'
        urlParts = self.url.split('/')
        imageAttachment = '.. image:: http://parati.dca.fee.unicamp.br/media/Attachments/' + urlParts[5] + '/' + urlParts[6] + '/' + self.imageFilePath
        outputText += imageAttachment + '\n\n'
        for line in self.mossResults:
            sourceA, sourceB, link = line[0][0], line[1][0], line[0][2]
            newLine = str(sourceA) + ' and ' + str(sourceB) + ' may be suspicious. Details: ' + '`' + str(link) + '` \n\n'
            outputText += newLine 
        for line in self.localResults:
            sourceA, sourceB, commonText = line[0], line[1], self.localResults[line]
            newLine = str(sourceA) + ' and  ' + str(sourceB) + ' may be suspicious. They share the following substring: \n ' + commonText + '\n\n'
            outputText += newLine
        return outputText